%%
% 
%  PREFORMATTED
%  TEXT
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%  Midi2Arduino
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%  Init 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
clear;
format;
format compact;
close(gcf);
close(gcf);
close(gcf);
close(gcf);


% midi = readmidi('jesu.mid')
% midi = readmidi('Magnetic Fields 1e.mid')
% midi = readmidi('viva-la-vida.mid')
% midi = readmidi('Coldplay - Clocks.mid')
midi = readmidi('Aerodynamic.mid')
% midi = readmidi('skyfall.mid')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%  Midi konvertieren
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% converting MIDI to audio
% (Fs = sample rate. here, uses default 44.1k.)
% [y,Fs] = midi2audio(midi);    

%% just display info:
% midiInfo(midi);

%% convert to 'Notes' matrix:
Notes = midiInfo(midi,0);
timebase=midi.ticks_per_quarter_note;
maxinstr=4; % letztes Instrument, das abgebildet wird
ind=find(Notes(:,2)<=maxinstr); % Instrumente beschrnken
ind2=ind(1:509); % Lnge beschrnken

track=round(Notes(ind2,1));
instrument=round(Notes(ind2,2));
pitch=round(Notes(ind2,3));
velocity=round(Notes(ind2,3));
noteon=round(24*4*Notes(ind2,5));
noteoff=round(24*4*Notes(ind2,6));

if(0)
disp(' '); 
disp('byte track[] = {');  % -----
j=0;
temp='  ';
for i=1:length(track)
  temp=[temp num2str(track(i))];  % -----
  if i<length(track)
    temp=[temp ', '];
  end
  j=j+1;
  if (j>=16)
    temp=[temp ' // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='  ';
  end
end
if length(temp)
    temp=[temp '  // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='';
end
disp('}; ');
disp(' ');
end


disp(' '); 
disp('byte instr[] = {');  % -----
j=0;
temp='  ';
for i=1:length(track)
  temp=[temp num2str(instrument(i))];  % -----
  if i<length(track)
    temp=[temp ', '];
  end
  j=j+1;
  if (j>=16)
    temp=[temp ' // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='  ';
  end
end
if length(temp)
    temp=[temp '  // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='';
end
disp('}; ');
disp(' ');


disp(' '); 
disp('byte notes[] = {');  % -----
j=0;
temp='  ';
for i=1:length(track)
  temp=[temp num2str(pitch(i))];  % -----
  if i<length(track)
    temp=[temp ', '];
  end
  j=j+1;
  if (j>=16)
    temp=[temp ' // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='  ';
  end
end
if length(temp)
    temp=[temp '  // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='';
end
disp('}; ');
disp(' ');

disp(' '); 
disp('byte velocity[] = {');  % -----
j=0;
temp='  ';
for i=1:length(track)
  temp=[temp num2str(velocity(i))];  % -----
  if i<length(track)
    temp=[temp ', '];
  end
  j=j+1;
  if (j>=16)
    temp=[temp ' // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='  ';
  end
end
if length(temp)
    temp=[temp '  // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='';
end
disp('}; ');
disp(' ');


disp(' '); 
disp('int noteon[] = {');  % -----
j=0;
temp='  ';
for i=1:length(track)
  temp=[temp num2str(noteon(i))];  % -----
  if i<length(track)
    temp=[temp ', '];
  end
  j=j+1;
  if (j>=16)
    temp=[temp ' // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='  ';
  end
end
if length(temp)
    temp=[temp '  // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='';
end
disp('}; ');
disp(' ');

if(0)
disp(' '); 
disp('int noteoff[] = {');  % -----
j=0;
temp='  ';
for i=1:length(track)
  temp=[temp num2str(noteoff(i))];  % -----
  if i<length(track)
    temp=[temp ', '];
  end
  j=j+1;
  if (j>=16)
    temp=[temp ' // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='  ';
  end
end
if length(temp)
    temp=[temp '  // ' num2str(i-j+1) '-' num2str(i)];  
    j=0;
    disp(temp);
    temp='';
end
disp('}; ');
disp(' ');
end
